//初始化?
let obj1 = null
let obj2 = null
let uhfApi = uni.requireNativePlugin("Lizii-uhfmagic-sdk");
let rfidStart = true
export function allScan(HTML5_PLUS_RUNTIME_MAIN_ACTIVITY, POC_KEY_DOWN_OBJ, filter, typeset) {
	let HTML5_PLUS_REFLECT_BROADCASTRECEIVER =
		"io.dcloud.feature.internal.reflect.BroadcastReceiver" // html5+ 创建数据监听api
	let HTML5_PLUS_CONTENT_INTENT = "android.content.Intent" // html5+ 初始化上下文
	let HTML5_PLUS_CONTENT_INTENTFILTER = "android.content.IntentFilter" // html5+ 暴露接口
	let HTML5_PLUS_KEY_DOWN = "com.aoro.poc.key.down" // 按钮被按下
	// 广播对象
	// 扫描对象
	let SCANOBJ = {
		ACTION_SCAN_RESULT: "com.action.SCAN_RESULT",
		SCAN_SERVICE: "com.action.INIT_SCAN", // 扫描权限
		SCAN_RESULT: "com.action.SCAN_RESULT", // 扫描结果
		SCAN_BEGIN: "com.action.START_SCAN", // 开始扫描
		SCAN_END: "com.action.STOP_SCAN", // 关闭扫描
	}
	//初始化
	let HTML5_PLUS_CONTENT_INTENT_CLASS = plus.android.importClass(HTML5_PLUS_CONTENT_INTENT);
	HTML5_PLUS_RUNTIME_MAIN_ACTIVITY = plus.android.runtimeMainActivity(); // HTML5_PLUS 获取 activity

	// 权限
	let intentServer = new HTML5_PLUS_CONTENT_INTENT_CLASS(SCANOBJ.SCAN_SERVICE);
	HTML5_PLUS_RUNTIME_MAIN_ACTIVITY.sendBroadcast(intentServer);

	// HTML5_PLUS 创建数据监听函数
	POC_KEY_DOWN_OBJ = plus.android.implements(
		HTML5_PLUS_REFLECT_BROADCASTRECEIVER, {
			onReceive: (context, intent) => {
				plus.android.importClass(intent);
				// 红外扫描结果
				if (intent.getAction() === SCANOBJ.SCAN_RESULT) {
					let _data_ = intent.getByteArrayExtra("scanContext")
					let codeStr = byteToString(_data_)
					console.log(`回调数据:${codeStr}`)
					uni.$emit('scancodemsg', {
						msg: codeStr
					})
				}
			}
		}
	);
	let IntentFilter = plus.android.importClass(HTML5_PLUS_CONTENT_INTENTFILTER); // 暴露接口对象
	filter = new IntentFilter();
	filter.addAction(SCANOBJ.ACTION_SCAN_RESULT); // 红外 扫描结果，广播
	filter.addAction(HTML5_PLUS_KEY_DOWN); // 按钮对按钮，广播
	filter.addAction(SCANOBJ.SCAN_RESULT); // 红外 扫描结果，广播
	obj1 = HTML5_PLUS_RUNTIME_MAIN_ACTIVITY
	obj2 = POC_KEY_DOWN_OBJ
	let arr = [HTML5_PLUS_RUNTIME_MAIN_ACTIVITY, POC_KEY_DOWN_OBJ, filter]
	return arr
}

//开始
export function startScan(HTML5_PLUS_RUNTIME_MAIN_ACTIVITY, POC_KEY_DOWN_OBJ, filter) {
	obj1.registerReceiver(obj2, filter);
	console.log("开始监听扫描设备-" + obj2 + "进程")
}
//结束
export function stopScan(HTML5_PLUS_RUNTIME_MAIN_ACTIVITY, POC_KEY_DOWN_OBJ) {
	obj1.unregisterReceiver(obj2);
	console.log("结束监听扫描设备-" + obj2 + "进程")
}

//初始化RFID
export function initRFID() {
	//setCallback 可以多次调用 扫码结果回调
	uhfApi.setCallback(function(res) {
		console.log(res);
		var event = res.event;
		if (event == "onEpc") {
			// res.data  epc 数组  没有信号强度
			let arr = []
			res.data.map(item => {
				arr.push(byteToString(item))
				console.log(arr)
			})
		}

	});
	uhfApi.init({
		serialPortPath: "/dev/ttyWK2", //串口地址 ，不传默认为‘/dev/ttysWK2’
		power: 26 //功率，不传默认26 取值14-26
	});
}

//RFID开始存盘
export function inventoryRealTime() {
	//true 开始 false 停止
	uhfApi.inventoryRealTime(rfidStart);
	rfidStart = false
},

//RFID停止存盘
export function inventoryRealTime() {
	//true 开始 false 停止
	uhfApi.inventoryRealTime(rfidStart);
	rfidStart = false
},


export function byteToString(arr) {
	if (typeof arr === 'string') {
		return arr;
	}
	var str = '',
		_arr = arr;
	for (var i = 0; i < _arr.length; i++) {
		var one = _arr[i].toString(2),
			v = one.match(/^1+?(?=0)/);
		if (v && one.length == 8) {
			var bytesLength = v[0].length;
			var store = _arr[i].toString(2).slice(7 - bytesLength);
			for (var st = 1; st < bytesLength; st++) {
				store += _arr[st + i].toString(2).slice(2);
			}
			str += String.fromCharCode(parseInt(store, 2));
			i += bytesLength - 1;
		} else {
			str += String.fromCharCode(_arr[i]);
		}
	}
	return str;
}